unit crt3;

interface

uses crt,strings;

const

{ edline }
  editableCharsetMin = 28;
  editableCharsetMax = 254;

{ keys }

  _none_   = $FFFF;
  _null_   = $0;

  { basic }
  _Enter_  = 13;
  _Esc_    = 27;
  _Insert_ = 1082;
  _Delete_ = 1083;
  _Home_   = 1071;
  _End_    = 1079;
  _PgUp_   = 1073;
  _PgDown_ = 1081;
  _BackSpace_ = 8;
  { arrows }
  _arLeft_ = 1075;
  _arRight_= 1077;
  _arUp_   = 1072;
  _arDown_ = 1080;
  _Ctrl_arRight_ = 1116;
  _Ctrl_arLeft_  = 1115;
  _Shift_arLeft_ = 2075;
  _Shift_arRight_= 2077;
  _Shift_arUp_   = 2072;
  _Shift_arDown_ = 2080;

  { Ctrl + ? }
  _Ctrl_PgUp_    = 1132;
  _Ctrl_PgDown_  = 1118;
  _Ctrl_Home_    = 1119;
  _Ctrl_End_     = 1117;
  _Ctrl_N_       = 14;
  _Ctrl_Q_       = 17;
  _Ctrl_K_       = 11;
  _Ctrl_X_       = 24;

  { Alt + ? }
  _Alt_X_        = 1045;

  { keys }
  _0_      = 48;
  _9_      = 59;

  _y_      = 121;
  _n_      = 110;
  _f_      = 102;
  _p_      = 112;
  _q_      = 113;
  _r_      = 114;
  _e_      = 101;
  _c_      = 99;
  _h_      = 104;
  _t_      = 116;
  _m_      = 109;
  _x_      = 120;

  { function keys }
  _F1_     = 1059;



  { enabled charset for wordSkip }
  wordCharset = ['A'..'Z','a'..'z',#128..#169,#181..#184,#198,#199,#208..#216,#222,'0'..'9'];

  { hexedit }
  maxEquAddr = 8; { pocet mnozin ekival. adres  }
  maxEqus = 4; { pocet adresovych ekvalentu  }


type

  TFileName = string[13];
  TPath = string;
  TTitle= string[25];

  TWin = record
           x1,x2,y1,y2:byte;
         end;
  TKey = word;

  TStringsBase = record
               pred,next:pointer;
               texline: PChar;
             end;
  TStrings = ^TStringsBase;

  TMarkers = array[_0_.._9_] of word;




  TCurPos = record
              y:word;
              x:byte;
            end;

{ texedit }
  TTexeditTitle= string[25];
  TTexeditDescript = record
                    win:TWin;  { window position }
                    curPos:TCurPos;  { screen cursor position }
                    lineOfs: word;   { Y lines offset }
                    editable: boolean; { enable edit text }
                    kotva: pointer;
                    title: TTitle;
                  end;

{ hexedit }
  ThexeditAddrLabel= string[10];
  ThexeditDataType = (hexeditByte,hexeditWord,hexedit12bit);
  ThexeditData = word;
  ThexeditDataAttrib = byte;
  ThexeditAttribKeys= array [0..7] of TKey;
  ThexeditAttribColors= array [0..7] of byte;
  TEquAdr=array [1..MaxEquAddr] of array [1..MaxEqus] of word;
  ThexeditDescript = record
                       win: TWin;
                       columns: byte;  { 8 / 16 .. }
                       dataType: THexeditDataType;
                       title: TTitle;
                       addrOfs: word;
                       curAddr: word;
                       leftOfs: byte;
                       LabelLen: byte; { length of AddressLabel ex.STATUS }
                       GetAddrLabel:procedure; { pointer to procedure: GetAddrLabel,
                                  to change color of label choose
                                  hexeditLabelTextColor
                                  hexeditLabelbgColor! }
                       Attrib:boolean;
                       EquAdr: TEquAdr;
                       FullView: boolean;
                     end;
{ messages }
  TMessagesDescript = record
                      win: TWin;
                      title: TTitle;
                      editable: boolean;
                      msgOfs: word;
                      destFile: TFileName;
                      destPath: TPath;
                      sourceFile: TFileName;
                      sourcePath: TPath;
                      reload,rewrite: boolean; { initialize IN/OUT procedure }
                      buffers: byte; { max. # stored messages }
                     end;
  TMessages = TStrings;

var

  sysReq: boolean; { TERMinating signal for all process }

{ edline vars. }

  edlineTextColor,edlineBgColor,
  edlineMarkedTextColor,edlineMarkedBgColor: byte;
  edlineExit: boolean;
  edlineInsert: boolean;
  edlineCurPtr: byte;        { character pointer }
  edlineEditOver: boolean;   { edit text longer than defined in L var. }
  edlineBlankDELETEleave: boolean; { leave if string='' and DELETE key pressed }
  edlineCurHomeBACKSPACEleave: boolean; { leave if CurPtr=0 + Backspace pressed }

  edlineMarkLineOverLeave: boolean; { if cur>len(str) or cur<len then leave... }

  edlineEveryModify: boolean;
  edlineEditable: boolean;
  edlineMarkX1,edlineMarkX2: byte; { marked text .. }
  edlineMarkColumn,                { mark coulumn }
  edlineLeaveLRkey:boolean;
  edlineLastKey:Tkey;


{ texedit }

  texeditNumberLines: boolean;
  texeditLeftDist: byte;

  texeditBgColor,texeditTextColor,
  texeditLinesNumbersTextColor,
  texeditLinesNumbersBgColor,
  texeditLineTextColor,
  texeditLineBgColor,
  texeditTermLineBgColor,
  texeditMarkerTextColor,
  texeditMarkerBgColor,
  texeditTitleTextColor,
  texeditTitleBgColor: byte;
  texeditMarkers: TMarkers;
  texeditClipboard: TStrings;
  texeditExit: boolean;
  texeditLineHighlight,
  texeditEditOver:boolean;

{ hexedit }
  hexeditBgColor,hexeditTextColor: byte;
  hexeditEditBgColor,hexeditEdittextColor: byte;
  hexeditAddressTextColor,
  hexeditAddressBgColor,
  hexeditTitleTextColor,
  hexeditTitleBgColor : byte;
  hexeditExit: boolean;
  hexeditEditable:boolean;
  hexeditAddrLabel: ThexeditAddrLabel;
  hexeditLabelAddr: word; { address to get label.. }
  hexeditLabelTextColor,hexeditLabelBgColor: byte;
  hexeditAttribKeys: ThexeditAttribKeys;
  hexeditAttribTextColor,hexeditAttribBgColor: ThexeditAttribColors;

{ message box }

  msgCurMessages: TMessages;           { pointer to current message buffer }
  msgCurDescript: ^TMessagesDescript; { pointer to current message buffer's
                                        descriptor }
  msgTextColor,
  msgBgColor: byte;


{ get key }
  switchKeys: word;
  key: TKey;  { storage of last keyboard pressed key }
  BIOSswitchKeysStat: word absolute $0000:$0417;



function hexToInt(h:string;var errPosition:byte):longInt;
function IntToHex(x:word;nums:byte):string;
function IntToBin(w:word;nums:byte):string;

procedure edline(x,y,l:byte;var line:string);

{ TStrings }
procedure addLine(var tex:TStrings;Stexline:string);
procedure deleteLine(var tex:TStrings);
procedure insertLine(var tex:TStrings;Stexline:string);
procedure modifyLine(var tex:TStrings;texline:string);
procedure goNextLine(var tex:TStrings);
procedure goPredLine(var tex:TStrings);
function getCurLine(var tex:TStrings): string;
procedure goForLines(var tex:TStrings;n:word);
procedure goBackLines(var tex:TStrings;n:word);
function getNLines(var tex:TStrings):word;
procedure destroyStrings(var tex:TStrings);

{ markers - part of TEXEDIT! }
function lineMarked(l:word;var m:TKey):boolean;
procedure eraseMarkers(var m:TMarkers);




{ TEXedit }
procedure texedit(var ds:TTexeditDescript;var tex:TStrings);

{ HEXedit }
procedure hexedit(var ds:THexeditDescript;var d: array of THexeditData;
                  var attrib: array of THexeditDataAttrib);

{ messages }
procedure Msg(m: string);
procedure viewMsg(var m: TMessages; var ds: TMessagesDescript);
procedure switchMsgBox(var m: TMessages; var ds: TMessagesDescript);

{ misc. of CRT3 }
function getKey:TKey;
function getKeyInt:TKey;
function inKey:TKey;


implementation

var i,j:word;

{
--- convert integer to hex string -------------------------------------
}

function IntToHex(x:word;nums:byte):string;
var
  i:byte;
  result: string;
begin
  result:= '';
  for i:=0 to nums-1 do begin
    if (x and $000F) <10 then
      result:= char((x and $000F)+48) + result
    else
      result:= char((x and $000F)+55) + result;
    x:= x shr 4; {ext #}
  end;
  IntToHex:= result;
end;

function IntToBin(w:word;nums:byte):string;
var
  i:byte;
  x:word;
  result:string;
begin
  result:='';
  x:=w;
  for i:=1 to nums do begin
    if (x mod 2)=1 then result:= '1'+result
     else result:= '0'+result;
    x:= x div 2;
  end;
  intToBin:= result;
end;

{
--- convert HEX to integer --------------------------------------------
}

function hexToInt(h:string;var errPosition:byte):longInt;
var
  i:byte;
  result:word;
  exp: longInt;
begin
  result:= 0;
  errPosition:=0;
  exp:= 1;
  for i:= length(h) downto 1 do begin
    case h[i] of
      '0'..'9': result:= result + (exp * (byte(h[i])-48));
      'A'..'F': result:= result + (exp * (byte(h[i])-55));
      'a'..'f': result:= result + (exp * (byte(h[i])-87));
      else errPosition:= i;
    end;
    exp:= exp * $10;
  end;
  hexToInt:= result;
end;


{
--- shift pressed ? --------------------------------------------------

vraci 1 kdyz je ztlacen levy i pravy shift
}

function sw_Shift: boolean;
begin
  sw_Shift:= not ((switchKeys and $0003)=0)
end;

{
--- returns pressed key -----------------------------------------------

: wait for keypressed.
}

function getKey:TKey;
var
  key: TKey;
begin
  key:= byte(readkey);
  if key=0 then begin
    key:= byte(readkey);
    key:= key + 1000; { shift Ctrl + ... }
    if sw_Shift then key:= key + 2000;
  end;
  switchKeys:= BIOSswitchKeysStat;


  getKey:= key;
end;



{
--- returns pressed key ----------------------------------------------

: testing keypressed, if not leave this routine.
}

function inKey:TKey;
begin
  inKey:=_none_;
  if keypressed then inKey:= getKey;
end;

{
--- returns pressend key, interrupt by setting sysReq -----------------
}

function getKeyInt:TKey;
var
  key:TKey;
begin
  repeat
    key:= _none_;
    key:= inKey;
  until (key<>_none_) or sysReq;
  getkeyInt:= key;
end;


{
--- change cursor -----------------------------------------------------
}

procedure changeCursor;
begin
  case edlineInsert of
    true: asm          { small }
            mov ah,$01
            mov ch,$11
            mov cl,$12
            int $10
          end;
    false:asm          { large }
            mov ah,$01
            mov ch,$02
            mov cl,$12
            int $10
          end;
  end;
end;

{
--- goto next word ----------------------------------------------------
}
function gotoNextWord(var s:string; cur:byte): byte;
var
  i,l: byte;
  enWord: boolean;
begin
  i:= cur;
  l:= length(s);
  enWord:= false;
  repeat
    inc(i);
    if not (s[i] in wordCharset) then enWord:= true;
  until ((s[i] in wordCharset) and enWord) or (i>=l);
  if i>=l then i:= l+1;
  gotoNextWord:= i-1;
end;

{
--- goto pred word ----------------------------------------------------
}
function gotoPredWord(var s:string; cur:byte): integer;
var
  i,l: byte;
  enWord: boolean;
begin
  i:= cur;
  l:= length(s);
  enWord:= false;
  if i>1 then
    repeat
      dec(i);
      if (s[i] in wordCharset) then enWord:= true;
    until ((not(s[i] in wordCharset)) and enWord) or (i<=1);

  if i>=l then i:= 1;
  gotoPredWord:= i;
end;


{
--- edit line ---------------------------------------------------------

ukoncuje se pomoci klaves Enter, sipky nahoru, Dolu (zmeni text), Esc
ukoci rutinu, ale nezmeni line.

}

procedure edline(x,y,l:byte;var line:string);
label
 edlineRedraw, edlineEnd;
var
  eline: string;
  Oline: string[80];
  exitf,dontErase: boolean;
  lineLength:byte;
  intExit: boolean;
  i: word;
  leftOfs:byte;
  deltaOfs: byte;

procedure clearEditSpace;
var
  i:word;
begin
  if (length(eline)-leftOfs)<l then begin
    Oline:= '';
    gotoxy(x+length(eline)-leftOfs,y);
    for i:=(x+length(eline)-leftOfs) to x+l do Oline:= Oline + ' ';
    write(Oline);
  end;
end;

begin
  exitf:= false;
  eline:= line;
  leftOfs:= 0;
  { print string }
  textColor(edlineTextColor);
  textBackground(edlineBgColor);

  changeCursor;
  dontErase:= false;
  intExit:= false;
  { edit line }
  repeat
    edlineRedraw:
    if not dontErase then begin
      clearEditSpace;                    { clear blank space }
    end;

    gotoxy(x,y);                         { refresh text }
    Oline:= '';                          { truncate to length - chars.! }
    lineLength:= length(eline);
    if lineLength>0 then begin
      if (lineLength-leftOfs)>l then begin { edit over the LineLength(l) }
        for i:= leftOfs to (l+leftOfs-1) do  { print part of line }
          Oline:= Oline + eline[i+1];
        Oline:= Oline;
      end
      else
        for i:= leftOfs to lineLength-1 do   { print whole end of/line }
        Oline:= Oline + eline[i+1];
    end;

    if (lineLength-leftOfs)<l then
      write(Oline+ ' ')                  { print }
    else
      write(Oline);

    gotoxy(x+edlineCurPtr,y);            { refresh cursor position }
    dontErase:= false;
    { get operator's command }
    if intExit then goto edlineEnd;
    if (not edlineExit) then begin
    key:= getKeyInt;

     case key of

      _Insert_: begin                    { change Insert/Overwrite }
        edlineInsert:= not edlineInsert;
        changeCursor;
        dontErase:= true;
      end;

      _Delete_: begin                    { delete character }
        if edlineEditable then begin
         if edlineBlankDELETEleave
           and ((edlineCurPtr+leftOfs)>=length(eline)) then begin
          exitf:= true;
          line:= eline;
         end
         else
          delete(eline, leftOfs+edlineCurPtr+1, 1)
        end;
      end;

      _Home_:   begin                    { cursor at the begin of string }
        edlineCurPtr:= 0;
        leftOfs:=0;
        dontErase:= true;
      end;

      _End_:    begin                    { cursor at the end od str. }
        leftOfs:= 0;
        lineLength:= length(eline);
        if lineLength > l then
          leftOfs:= lineLength - l;      { left line shift }

        edlineCurPtr:= length(eline)-leftOfs;
        dontErase:= true;
      end;

      _BackSpace_: begin                 { backspace delete }
        if edlineEditable then begin
         if edlineCurPtr>0 then begin
          delete(eline,leftOfs+edlineCurPtr,1);
          dec(edlineCurPtr);
         end
         else
          if leftOfs>0 then begin
            dec(leftOfs);
            delete(eline,leftOfs,1);
          end
          else
            exitf:= edlineCurHomeBACKSPACEleave; { leave edline }
        end;
      end;

      _arLeft_: begin
        if edlineCurPtr>0 then
          dec(edlineCurPtr)
        else begin
          if edlineLeaveLRkey then intExit:=true;
          if leftOfs>0 then begin
            dec(leftOfs);
          end;
        end;
        dontErase:= true;
      end;

      _arRight_:begin
        if (edlineCurPtr<(l-1)) then
          inc(edlineCurPtr)
        else  begin
          if edlineLeaveLRkey then intExit:=true;
          if (leftOfs<(255-l)) and edlineEditOver then
            inc(leftOfs);
        end;
        dontErase:= true;
      end;

      _Ctrl_arRight_:begin { jump to next word }
        lineLength:= length(eline);
        edlineCurPtr:= gotoNextWord(eline, edlineCurPtr+leftOfs+1);
        if edlineCurPtr>=(l-1) then begin
          leftOfs:= (edlineCurPtr - l)+1;
          edlineCurPtr:= l-1;
        end;
      end;

      _Ctrl_arLeft_: begin
        lineLength:= length(eline);
        deltaOfs:= gotoPredWord(eline, edlineCurPtr+leftOfs+1);
        if edlineCurPtr<1 then begin
          leftOfs:= deltaOfs;
        end
        else
          if deltaOfs>= leftOfs then
            edlineCurPtr:= deltaOfs - leftOfs
          else begin
            edlineCurPtr:= 0;
            leftOfs:= deltaOfs;
          end;
      end;

      { mark text }

      _Shift_arRight_: begin

      end;

      _Shift_arLeft_: begin

      end;



      { editable characters }

      editableCharsetMin..editableCharsetMax: begin
        if ((edlineCurPtr+leftOfs)<255) and edlineEditable then begin
         case edlineInsert of
         { insert character }
          true: begin
            lineLength:=length(eline);

            if ((edlineCurPtr+1)>=l) and edlineEditOver then
              inc(leftOfs)
            else
              if edlineCurPtr<l then inc(edlineCurPtr);



            if (lineLength-leftOfs)< l then begin
              if (edlineCurPtr+leftOfs)>lineLength then begin
                  { fill ' ' to cursor }
                for i:=(lineLength+1) to (leftOfs+edlineCurPtr-1) do
                  eline:= eline + ' ';
              end;
              insert(char(key),eline,edlineCurPtr+leftOfs);
              dontErase:= true;
            end;
          end;

          false: begin
            lineLength:=length(eline);
            if (edlineCurPtr+leftOfs)< lineLength then begin
              eline[leftOfs+edlineCurPtr+1]:= char(key);
              inc(edlineCurPtr);
              dontErase:= true;
              { pro hexedit - vypadne a posune doprava }
              if edlineLeaveLRkey and (edlineCurPtr>(l-1)) then begin
                intExit:=true;
                key:= _arRight_;
                goto edlineRedraw;
              end;
            end
            else begin
              if (edlineCurPtr+leftOfs)>lineLength then begin
                  { fill ' ' to cursor }
                for i:=(lineLength+1) to (leftOfs+edlineCurPtr) do
                  eline:= eline + ' ';
              end;
              if lineLength< 255 then begin
                if edlineCurPtr<l then begin
                  inc(edlineCurPtr);
                  eline:= eline + char(key);
                end
                else begin
                  if edlineEditOver then begin
                    eline:= eline + char(key);
                    inc(leftOfs);
                  end;
                end;
                dontErase:= true;
              end;
            end;
          end;
         end;
        end;
      end;
      else
        exitf:= true; { for commands... }
     end;
    end;
    edlineEnd:
  until (key = _Enter_) or (key=_Esc_) or edlineExit or
        (key = _arUp_) or (key =_arDown_) or exitf or sysReq or intExit;

  if (key = _Enter_) or (key = _arUp_) or (key =_arDown_) or
     edlineEveryModify or intExit then line:=eline; { valid editing }

  if edlineLeaveLRkey then
     edlineLastKey:=key;
  if not exitf then key:= 0;
end;


{
--- scrollScreenDown --------------------------------------------------
}
procedure scrollScreenDown;
begin
  gotoxy(1,1);
  insLine;
end;

{
--- scrollScreenUp ----------------------------------------------------
}
procedure scrollScreenUp;
begin
  gotoxy(1,hi(windMax)-hi(windMin)+1);
  writeln;
end;

{
--- add line to the end of TStrings data type -------------------------

* vyzaduje promenou tex jako KOTVU!

* pointer NEOVLIVNUJE!!! tudiz po 1. volani a nastaveni pointeru se JIZ
  nemusime starat o nastavovani pointeru na KOTVU!!!

* v tex vraci aktuali pointer na pridanou lajnu

-je stejna jako insertLine.;

}
procedure addLine(var tex:TStrings;Stexline:string);
var
  newLine,predP: TStrings;
  saveKotvu: pointer;
  texline: PChar;
begin

  new(newLine);
  getMem(newLine^.texline,length(Stexline)+1); { allocate mem. }
  strPCopy(newLine^.texline,Stexline);         { copy }

  if tex<>nil then begin
    saveKotvu:= tex;            { save current pointer - KOTVA }

    newLine^.pred:= tex^.pred;  { build-in to database }
    newLine^.next:= tex;
    predP:= tex^.pred;
    predP^.next:= newLine;

    tex^.pred:= newLine;
    tex:= newLine;
    tex:= saveKotvu;            { refresh KOTVU }
  end
  else begin                    { build new }
    tex:= newLine;
    tex^.next:= tex;
    tex^.pred:= tex;
  end;
end;

{
--- destroy strings ---------------------------------------------------
}
procedure destroyStrings(var tex:TStrings);
var
  pseudokotva,next: pointer;
begin
  if tex<>nil then begin
    pseudokotva:= tex;
    repeat
      next:= tex^.next;
      strDispose(tex^.texline);
      dispose(tex);
      tex:= next;
    until next=pseudokotva;
{    strDispose(tex^.texline);
    dispose(tex);}
    tex:= nil;
  end;
end;

{
--- delete line from strings ------------------------------------------

 zmaze aktualni texline

 vraci ukazatel na nasledujici lajnu (tu co nasledovala za zmazanou)
}

procedure deleteLine(var tex:TStrings);
var
  predP, nextP: TStrings;
begin
  predP:= tex^.pred;       { prepare to contact database }
  nextP:= tex^.next;

  predP^.next:= nextP;     { CONTACT }
  nextP^.pred:= predP;

  strDispose(tex^.texline);{ free text memory }
  dispose(tex);            { free line mem. }
  tex:= nextP;
end;

{
--- insert line to current position -----------------------------------
}

procedure insertLine(var tex:TStrings;Stexline:string);
var
  newLine,predP: TStrings;
begin
  new(newLine);
  getMem(newLine^.texline,length(Stexline)+1); { allocate mem. }
  strPCopy(newLine^.texline,Stexline);         { copy }

  newLine^.pred:= tex^.pred;  { build-in to database }
  newLine^.next:= tex;
  predP:= tex^.pred;
  predP^.next:= newLine;

  tex^.pred:= newLine;
  tex:= newLine;
end;

{
--- modify line -------------------------------------------------------
}

procedure modifyLine(var tex:TStrings;texline:string);
begin
  strDispose(tex^.texline);
  getMem(tex^.texline,length(texline)+1);
  strPCopy(tex^.texline,texline);
end;

{
--- sets the current pointer to next line -----------------------------
}
procedure goNextLine(var tex:TStrings);
begin
  tex:= tex^.next;
end;

{
--- sets the current pointer to 'pred' line ---------------------------
}

procedure goPredLine(var tex:TStrings);
begin
  tex:= tex^.pred;
end;

{
--- get current line --------------------------------------------------
}

function getCurLine(var tex:TStrings): string;
begin
  getCurLine:= strPas(tex^.texline);
end;

{
--- go forward N line -------------------------------------------------

vyzaduje tex jako KOTVU jinak se to chova jako offsetLine;
}

procedure goForLines(var tex:TStrings;n:word);
var
  i: word;
begin
  for i:=1 to n do
    tex:= tex^.next;
end;

{
--- go backward N line ------------------------------------------------

vyzaduje tex jako KOTVU jinak se to chova jako offsetLine;
}

procedure goBackLines(var tex:TStrings;n:word);
var
  i:word;
begin
  for i:=1 to n do
    tex:= tex^.pred;
end;

{
--- get Number of Lines -----------------------------------------------

vraci pocet lajn
}
function getNLines(var tex:TStrings):word;
var
  n: word;
  pseudokotva: pointer;
begin
  n:=0;
  pseudokotva:= tex;
  if tex<>nil then begin
    if tex^.next=tex then n:= 1
    else begin
      n:=1;
      repeat
        inc(n);
        tex:= tex^.next;
      until tex^.next=pseudokotva;
    end;
  end;
  getNLines:= n;
  tex:= pseudokotva;
end;

{
--- line marked ? -----------------------------------------------------

marker at this line ?
}
function lineMarked(l:word;var m:TKey):boolean;
var
  i: byte;
begin
  lineMarked:= false;
  for i:=_0_ to _9_ do
    if texeditMarkers[i]=l then break;
  if texeditMarkers[i]=l then begin
    lineMarked:= true;
    m:= i;
  end;
end;

{
--- erase markers -----------------------------------------------------
}
procedure eraseMarkers(var m:TMarkers);
var
  i: TKey;
begin
  for i:=_0_ to _9_ do
    m[i]:= $FFFF;
end;



{
--- texedit -----------------------------------------------------------

edituje datovou struturu typu TStrings

pri predavani MUSI byt tex jako kotvicka!


}

procedure texedit(var ds:TTexeditDescript;var tex:TStrings);
var
  xlen,ylen,lines,i: word;
  eline: string;
  num, leftDist: string[6];
  kotva, saveK: pointer;
  lmark: TKey;

procedure drawTex;                       { refresh text data on screen }
var
  s: string;
  i: word;
  j: byte;
  dataEnd: boolean;
begin
  saveK:=tex;
  tex:= kotva;
  goForLines(tex,ds.lineOfs-ds.curPos.y);  { ...Yline TOP offset }
  edlineExit:=true;
  dataEnd:= false;
  for i:=1 to ylen do begin
    if not dataEnd then s:= getCurLine(tex);
    if texeditNumberLines then begin
      gotoxy(1,i);
      textColor(texeditLinesNumbersTextColor);  { draw line numbers }
      textBackground(texeditLinesNumbersBgColor);
      if not dataEnd then begin                 { end of textdata ? }
        str((i+ds.lineOfs-ds.curPos.y):5,num);
        if lineMarked(ds.lineOfs-ds.curPos.y+i-1,lmark) then begin { markers..}
          write(num);
          textColor(texeditMarkerTextColor);    { draw markers }
          textBackground(texeditMarkerBgColor);
          write(char(lmark));
        end
        else
          write(num+' ');
        textBackground(texeditBgColor);
        write(leftDist);
        edline(texeditLeftDist+7,i,xlen-6-texeditLeftDist,s);
      end
      else begin                                { YES, textdata end }
        write('      ');
        textBackground(texeditBgColor);
        write(leftDist);
        edline(texeditLeftDist+7,i,xlen-6-texeditLeftDist,s);
      end;
    end
    else begin
      gotoxy(1,i);
      textBackground(texeditBgColor);
      write(leftDist);
      if not dataEnd then
        edline(texeditLeftDist+1,i,xlen-texeditLeftDist,s)
      else
        edline(texeditLeftDist+1,i,xlen-texeditLeftDist,s);
    end;

    if tex^.next = kotva then begin
      dataEnd:= true; { write blank lines }
      s:='';
    end;
    goNextLine(tex);
  end;
  edlineExit:=false;
  tex:=saveK;
end;

begin
  if tex=nil then addLine(tex,'');
  kotva:= tex;
  lines:= getNLines(tex);
  { left blank space }
  leftDist:= '';
  for i:=1 to texeditLeftDist do leftDist:= leftDist + ' ';

  edlineBlankDELETEleave:= true;  { leave if string='' and DELETE key pressed }
  edlineCurHomeBACKSPACEleave:= true; { leave if CurPtr=0 + Backspace pressed }
  edlineEditable:= ds.Editable;
  edlineEveryModify:= true;
  edlineBgColor:= texeditBgColor;
  edlineTextColor:= texeditTextColor;
  edlineEditOver:=texeditEditOver;


  with ds do begin
    with win do begin         { width & height of edit win }
      window(x1,y1,x2,y2);
      textbackground(texeditTitleBgColor);
      clrscr;
      xlen:= abs(x2-x1)-1;
      ylen:= abs(y2-y1)+1;
      if ds.Title<>'' then begin { one line for title }
        gotoxy((abs(x2-x1) div 2)-(length(ds.Title) div 2),y1);
        textColor(texeditTitleTextColor);
        write(ds.Title);
        window(x1,y1+1,x2,y2);
        dec(ylen);
      end;
      textbackground(texeditBgColor);
      clrscr;
    end;
    edlineCurPtr:= curPos.x;     { X - cursor position }
  end;
  goForLines(tex,ds.lineOfs);


  drawTex;
  if not texeditExit then
  repeat
    eline:=getCurLine(tex);
    if texeditLineHighlight then begin
      edlineBgColor:= texeditLineBgColor;
      edlineTextColor:= texeditLineTextColor;
    end;

    with ds do begin
      if texeditNumberLines then begin
        gotoxy(1,curPos.y+1);
        textColor(texeditLinesNumbersTextColor);
        TextBackground(texeditLinesNumbersBgColor);
        str((ds.lineOfs+1):5,num);

        if lineMarked(ds.lineOfs,lmark) then begin { markers..}
          write(num);
          textColor(texeditMarkerTextColor);    { draw markers }
          textBackground(texeditMarkerBgColor);
          write(char(lmark));
        end
        else
          write(num+' ');

        edline(texeditLeftDist+7,curPos.y+1,xlen-6-texeditLeftDist,eline);
      end
      else
        edline(texeditLeftDist+1,curPos.y+1,xlen-texeditLeftDist,eline);
      modifyLine(tex,eline);
      curPos.x:=edlineCurPtr;
    end;
    edlineBgColor:= texeditBgColor;
    edlineTextColor:= texeditTextColor;


    case key of
      _arUp_:   begin
        if (ds.curPos.y>0) then begin
          dec(ds.curPos.y);
          dec(ds.lineOfs);
          goPredLine(tex);
        end
        else begin
          if ds.lineOfs>0 then begin  { scroll up screen }
            dec(ds.lineOfs);
            goPredLine(tex);
            scrollScreenDown;
          end;
        end;
        if texeditLineHighlight then drawTex;
      end;

      _arDown_: begin
        if (ds.curPos.y<(ylen-1)) and (ds.lineOfs<(lines-1)) then begin
          inc(ds.curPos.y);
          inc(ds.lineOfs);
          goNextLine(tex);
        end
        else begin
          if ds.lineOfs<(lines-1) then begin
            inc(ds.lineOfs);
            goNextLine(tex);
            scrollScreenUp;
          end;
        end;
        if texeditLineHighlight then drawTex;
      end;

      _Enter_: begin
        if ds.Editable then begin
          eline:= getCurLine(tex);
          modifyLine(tex,copy(eline,1,edlineCurPtr));
          eline:= copy(eline,edlineCurPtr+1,length(eline)-edlineCurPtr);
          goNextLine(tex);
          insertLine(tex,eline);
          if ds.curPos.y<(ylen-1) then inc(ds.curPos.y);
          inc(ds.lineOfs);
          inc(lines);
          edlineCurPtr:=0;
          drawTex;
        end;
      end;

      _Delete_:begin
        if  ds.Editable then begin
         if (ds.lineOfs+1)<lines then begin
          goNextLine(tex);
          eline:=getCurLine(tex); { store next line }
          deleteLine(tex);        { delete line below CursorY (next line) }
          goPredLine(tex);
          eline:= getCurLine(tex) + eline;
          modifyLine(tex,eline);  { contact line n+0 + n+1 }
          dec(lines);
          drawTex;
         end;
        end;
      end;
      _BackSpace_:begin
        if ds.Editable then begin
         if ds.lineOfs>0 then begin
          eline:= getCurLine(tex);
          deleteLine(tex);                 { delete line at CursorY }
          goPredLine(tex);
          i:= length(getCurLine(tex));     { save Xcur pos }
          eline:= getCurLine(tex) + eline; { contact line n+0 + n-1 }
          modifyLine(tex, eline);
          dec(ds.lineOfs);
          dec(ds.curPos.y);
          dec(lines);
          edlineCurPtr:= i;
          drawTex;
         end;
        end;
      end;

      _Ctrl_N_: begin
        texeditNumberLines:= not texeditNumberLines; { toggle number }
                                                     { bar }
        drawTex;
      end;

      _PgUp_: begin                        { scroll: page up }
        if ds.lineOfs>0 then begin
          if integer(ds.lineOfs)-integer(ylen)>=integer(ylen) then begin { $$$ arithmetic over!}
            ds.lineOfs:= ds.lineOfs - (ylen-1);
            goBackLines(tex,ylen-1);
          end
          else begin
            goBackLines(tex,ds.lineOfs);
            ds.lineOfs:= 0;
            ds.curPos.y:= 0;
          end;
        end;
        drawTex;
      end;

      _PgDown_: begin
        if ds.lineOfs<(lines-1) then begin
          if integer(lines)-integer(ds.lineOfs+ylen)>integer(ylen) then begin
            ds.lineOfs:= ds.lineOfs + (ylen-1);
            goForLines(tex,ylen-1);
          end
          else begin
            goForLines(tex,lines-ds.lineOfs-1);
            ds.lineOfs:= lines-1;
            if lines<ylen then
              ds.curPos.y:= lines-1
            else
              ds.curPos.y:= ylen-1;
          end;
        end;
        drawTex;
      end;

      _Ctrl_Q_: begin  { go to bookmark }
        i:= ds.lineOfs; { save current position }
        lmark:= getKey; { 0..9 }
        if lmark in [_0_.._9_] then
          if texeditMarkers[lmark]<$FFFF then  { empty marker ? }
            ds.lineOfs:= texeditMarkers[lmark]; { goto MARKER }
          if ds.lineOfs < ylen then
            ds.curPos.y:= ds.lineOfs;
        if i<ds.lineOfs then
          goForLines(tex,ds.lineOfs-i);
        if i>ds.lineOfs then
          goBackLines(tex,i-ds.lineOfs);

        drawTex;
      end;

      _Ctrl_K_: begin  { place bookmark }
        lmark:= getKey; { 0..9 }
        if lmark in [_0_.._9_] then
          texeditMarkers[lmark]:= ds.lineOfs; { current line }
      end;

      _Ctrl_PgUp_: begin
        goBackLines(tex, ds.curPos.y);
        ds.lineOfs:= ds.lineOfs - ds.curPos.y;
        ds.curPos.y:= 0;
        drawTex;
      end;

      _Ctrl_PgDown_: begin
        if lines>=ylen  then begin
          goForLines(tex,(ylen-1) - ds.CurPos.y);
          ds.lineOfs:= ds.lineOfs + (ylen-1) - ds.CurPos.y;
          ds.curPos.y:= ylen-1;
        end
        else begin
          goForLines(tex,(lines-1) - ds.CurPos.y);
          ds.lineOfs:= ds.lineOfs + ((lines-1) - ds.CurPos.y);
          ds.curPos.y:= lines-1;
        end;
        drawTex;
      end;

      _Ctrl_Home_: begin               { goto begin of texdata }
        goBackLines(tex,ds.lineOfs);
        ds.lineOfs:= 0;
        ds.curPos.y:= 0;
        drawTex;
      end;

      _Ctrl_End_: begin                { goto end of texdata }
        i:= ds.lineOfs;
        if lines>ylen  then begin
          ds.lineOfs:= lines- 1;
          ds.curPos.y:= ylen- 1;
        end
        else begin
          ds.curPos.y:= lines- 1;
          ds.lineOfs:= ds.curPos.y;
        end;

        if i<ds.lineOfs then
          goForLines(tex,ds.lineOfs-i);
        drawTex;
      end;
    end;
    ds.curPos.x:= edlineCurPtr;
  until (key= _Esc_) or sysReq;
  tex:= kotva;
end;



{
---- HEX editor ------------------------------------------------------


do pole d se pristupuje linearne : array [0..n] a ne XY, nasledna
uprava na XY bude provadet out rutina.

+dodelat kopirovani a TABULATORY v edlajnu!

}

procedure hexedit(var ds:THexeditDescript;var d: array of THexeditData;
                  var attrib: array of THexeditDataAttrib);
label EDITHVAL;
var
  ylen : word;
  xlen,L : byte;          { L: # chars / "byte" F, FF, FFF... }
  dlen: word;             { data length }
  adrLen: byte;            { # chars. / address F,FF,FFF,FFFF }
  colDist: byte;          { FF <-> FF distance }
  i: byte;
  key: TKey;
  hexs: string;
  inputErr: byte;
  newVal: word;
  attribMask,attribCode: byte;
{
-- print top columns' nubers
}

procedure printColumns;
var
  i: byte;
begin
  for i:=0 to ds.columns-1 do begin
    gotoxy(adrLen+1+ds.leftOfs+(i*colDist)+ds.LabelLen,1);
    write(intToHex(i,2));
  end;
end;

{
-- most significant attribute color setting ? ---
}
function setMSAttribColor(attrib:byte):boolean;
var
  i:byte;
begin
  if ds.Attrib then begin
  for i:= 7 downto 0 do
    if ((attrib shr i) and $01) = 1 then begin
      edlineTextColor:=hexeditAttribTextColor[i];
      edlineBgColor:=hexeditAttribBgColor[i];
      textColor(hexeditAttribTextColor[i]);
      textBackground(hexeditAttribBgColor[i]);
      break;
    end
    else begin
      edlineTextColor:=hexeditTextColor;
      edlineBgColor:=hexeditBgColor;
      textColor(hexeditTextColor);
      textBackground(hexeditBgColor);
    end;
  end;
end;



{
-- draw HEX ---
}
procedure drawHex(index,n:word);
var
  x,y,i: byte;

  svalue,s: string;
begin
  edlineExit:=true;
  for y:=index to index+n-1 do begin
    if (y*ds.columns)+x >= dlen then break;
    gotoxy(1,y+1);
    textBackground(hexeditAddressBgColor);
    textColor(hexeditAddressTextColor);
    svalue:=intToHex(ds.addrOfs +(y* ds.columns),adrLen);
    write(' '+svalue);
    for x:=0 to ds.columns-1 do begin
     if ds.addrOfs+(y*ds.columns)+x >= dlen then break;
     { address label }
     if (@ds.GetAddrLabel <> nil) and (ds.LabelLen>0) then begin
       hexeditLabelAddr:= ds.addrOfs+(y*ds.columns)+x;
       ds.GetAddrLabel;
       svalue:= hexeditAddrLabel;
       if (integer(length(svalue))-integer(ds.LabelLen))>0 then  { truncate str. }
         delete(svalue, ds.LabelLen+1,length(svalue)-ds.LabelLen);
       if (integer(ds.LabelLen))-integer(length(svalue))>0 then
         repeat
           svalue:= svalue + ' ';
         until length(svalue)>=ds.LabelLen;
       textColor(hexeditLabelTextColor);
       textBackground(hexeditLabelBgColor);

       gotoxy((x*colDist)+ds.leftOfs+adrLen+1,y+1);
       write(svalue);
     end;
     svalue:=intToHex(d[ds.addrOfs+(y*ds.columns)+x],L);

     setMSAttribColor(attrib[ds.addrOfs+(y*ds.columns)+x]);
     if ds.FullView then begin
       s:= intToBin(d[ds.addrOfs+(y*ds.columns)+x],L*4);
       svalue:=svalue +' '+s;
       if L=2 then begin
        svalue:=svalue +' '+ char(lo(d[ds.addrOfs+(y*ds.columns)+x]));
        edline((x*colDist)+ds.leftOfs+adrLen+1+ds.LabelLen,y+1,L+(L*4)+3,svalue);
       end
       else begin
         svalue:=svalue +' '+ char(lo(d[ds.addrOfs+(y*ds.columns)+x]));
         svalue:=svalue +' '+ char(hi(d[ds.addrOfs+(y*ds.columns)+x]));
         edline((x*colDist)+ds.leftOfs+adrLen+1+ds.LabelLen,y+1,L+(L*4)+5,svalue);
       end;

     end else
       edline((x*colDist)+ds.leftOfs+adrLen+1+ds.LabelLen,y+1,L,svalue);


    end;
  end;
  edlineExit:=false;
end;

{
-- attrib key query --
}
function isAttribToggleKey(key:TKey;var attribMask,attribCode:byte):boolean;
begin
  i:=0;
  isAttribToggleKey:= false;
  if ds.Attrib then begin
    repeat
     inc(i);
    until (key=hexeditAttribKeys[i-1]) or (i>7);
    attribMask:= $01;
    if key=hexeditAttribKeys[i-1] then begin
      attribMask:= attribMask shl (i-1);
      isAttribToggleKey:= true;
      attribCode:= i-1;
    end;
  end;
end;


procedure EquAdrAttrib(Adr:word;attribMask:byte);
var
  i:byte;

function IsInEqu(p:byte): byte;
var i: byte;
begin
  IsInEqu:= 0;
  for i:=1 to MaxEqus do
    if ds.EquAdr[p,i]=Adr then IsInEqu:=1;
end;

begin
  for i:=1 to MaxEquAddr do begin
     if IsInEqu(i)=1 then begin
       for j:=1 to MaxEqus do
         if (ds.EquAdr[i,j]<$FFFF) and (Adr<>ds.EquAdr[i,j]) then
           attrib[ds.EquAdr[i,j]]:=attrib[ds.EquAdr[i,j]] xor attribMask;
     end;
  end;
end;


begin
  case ds.dataType of
    hexeditByte: begin
                   dlen:= sizeOf(d) div 2;;
                   L:= 2;
                 end;
    hexeditWord: begin
                   dlen:= sizeOf(d) div 2;
                   L:= 4;
                 end;
    hexedit12bit:begin
                   dlen:= sizeOf(d) div 2;
                   L:= 3;
                 end;
  end;

  adrLen:= 2;
  if dlen>$FF then adrLen:= 3;
  if dlen>$FFF then adrLen:= 4;

{  inc(ds.leftOfs);}
  edlineBlankDELETEleave:= false;
  edlineCurHomeBACKSPACEleave:= false;
  edlineEditable:= hexeditEditable;
  edlineEveryModify:= false;
  edlineBgColor:= hexeditBgColor;
  edlineTextColor:= hexeditTextColor;
  edlineLeaveLRkey:= false;

  with ds do begin
    with win do begin
      xlen:= abs(x2-x1)-1;
      ylen:= abs(y2-y1);
      if ds.columns>2 then
        {colDist:= (xlen-adrLen-1-ds.leftOfs-ds.LabelLen) div )ds.columns-1)}
        colDist:= (xlen-adrLen-1-ds.leftOfs-L-ds.LabelLen) div (ds.columns-1)
      else
        colDist:=0;
      i:= 0;
      if ds.Title<>'' then begin { one line for title }
        window(x1,y1,x2,y1);
        textBackground(hexeditTitleBgColor);
        clrscr;
        gotoxy((abs(x2-x1) div 2)-(length(ds.Title) div 2),y1);
        textColor(hexeditTitleTextColor);
        write(ds.Title);
        dec(ylen);
        inc(i);
      end;
      window(x1,y1+i,x2,y1+i);
      textBackground(hexeditAddressBgColor);
      textColor(hexeditAddressTextColor);
      clrscr;
      printColumns;
      window(x1,y1+1+i,x2,y2);
      textBackground(hexeditBgColor);
      clrscr;
    end;
    edlineCurPtr:= 0;
  end;
  drawHex(0,ylen);

  repeat
    gotoxy((ds.curAddr mod ds.columns)*colDist +ds.leftOfs+adrLen+1+ds.LabelLen,
           ((ds.curAddr-ds.addrOfs) div ds.columns)+1);

    if (edlineLeaveLRkey) and (edlineLastKey<>_none_) then begin
      key:=edlineLastKey;
      edlineLastkey:=_none_;
    end
     else
       repeat key:=inkey; until ((key<>0) or sysReq);

    case key of
      _arUp_: begin
        if (ds.curAddr - ds.addrOfs)>=ds.columns then begin
          ds.curAddr:= ds.curAddr - ds.columns;
        end
        else
          if ds.addrOfs>(ds.columns-1) then begin
            ds.addrOfs:=ds.addrOfs- ds.columns;
            ds.curAddr:=ds.curAddr- ds.columns;
            scrollScreenDown;
            drawHex(0,1);
          end;
        if edlineLeaveLRkey then goto EDITHVAL;
      end;

      _arDown_: begin
        if ds.curAddr < (dlen - ds.columns) then
        if (ds.curAddr - ds.addrOfs)<((ylen-1)*ds.columns) then begin
          ds.curAddr:= ds.curAddr + ds.columns;
        end
        else
          if (dlen-ds.addrOfs)>(ds.columns*ylen) then begin
            ds.addrOfs:=ds.addrOfs+ ds.columns;
            ds.curAddr:=ds.curAddr+ ds.columns;
            scrollScreenUp;
            drawHex(ylen-1,1);
          end;
        if edlineLeaveLRkey then goto EDITHVAL;
       end;

      _PgDown_: begin
       for i:=1 to ylen do
       begin
        if ds.curAddr < (dlen - ds.columns) then
        if (ds.curAddr - ds.addrOfs)<((ylen-1)*ds.columns) then begin
          ds.curAddr:= ds.curAddr + ds.columns;
        end
        else
          if (dlen-ds.addrOfs)>(ds.columns*ylen) then begin
            ds.addrOfs:=ds.addrOfs+ ds.columns;
            ds.curAddr:=ds.curAddr+ ds.columns;
            scrollScreenUp;
            drawHex(ylen-1,1);
          end;
        if edlineLeaveLRkey then goto EDITHVAL;
       end;
       end;
      _PgUp_:begin
       for i:=1 to ylen do
       begin
        if (ds.curAddr - ds.addrOfs)>=ds.columns then begin
          ds.curAddr:= ds.curAddr - ds.columns;
        end
        else
          if ds.addrOfs>(ds.columns-1) then begin
            ds.addrOfs:=ds.addrOfs- ds.columns;
            ds.curAddr:=ds.curAddr- ds.columns;
            scrollScreenDown;
            drawHex(0,1);
          end;
        if edlineLeaveLRkey then goto EDITHVAL;
      end;
      end;

      _arLeft_:begin
        if (ds.curAddr mod ds.columns)>0 then
          dec(ds.curAddr);
        if edlineLeaveLRkey then goto EDITHVAL;
      end;

      _arRight_:begin
        if (ds.curAddr mod ds.columns)<(ds.columns-1) then
          inc(ds.curAddr);
        if edlineLeaveLRkey then goto EDITHVAL;
      end;

      _Ctrl_X_:begin edlineLeaveLRkey:= not edlineLeaveLRkey; end;

      _Enter_: begin
        EDITHVAL:
        hexs:= intToHex(d[ds.curAddr],L);
        edlineBgColor:=hexeditEditBgColor;
        edlineTextColor:=hexeditEdittextColor;
        edlineEditable:= hexeditEditable;
        edlineEditOver:= false;
        edlineCurPtr:=0;
        edline((ds.curAddr mod ds.columns)*colDist +ds.leftOfs+adrLen+1+ds.LabelLen,
               ((ds.curAddr-ds.addrOfs) div ds.columns)+1,
               L,hexs);
        newVal:=hexToInt(hexs,inputErr);
        edlineBgColor:=hexeditBgColor;
        edlineTextColor:=hexeditTextColor;
        if (inputErr=0) and (newVal<>d[ds.curAddr]) then
          d[ds.curAddr]:= newVal
        else begin
          textBackground(hexeditBgColor);
          textColor(hexeditTextColor);
          gotoxy((ds.curAddr mod ds.columns)*colDist +ds.leftOfs+adrLen+1+ds.LabelLen,
                 ((ds.curAddr-ds.addrOfs) div ds.columns)+1);
          write(intToHex(d[ds.curAddr],L));
        end;
        if ds.fullView then drawHex(ds.curAddr-ds.addrOfs,1);
      end;

      else begin
        { data atributes screen service }
        if isAttribToggleKey(key,attribMask,attribCode) then begin { query&color setting }

          attrib[ds.curAddr]:=attrib[ds.curAddr] xor attribMask;
          EquAdrAttrib(ds.curAddr,attribMask); { dalsi adresy, ktere jsou identicke }

          if ds.curAddr < (dlen - ds.columns) then
          if (ds.curAddr - ds.addrOfs)<((ylen-1)*ds.columns) then begin
            gotoxy((ds.curAddr mod ds.columns)*colDist +ds.leftOfs+adrLen+1+ds.LabelLen,
                 ((ds.curAddr-ds.addrOfs) div ds.columns)+1);
            { TAG attribute }
            if ((attrib[ds.curAddr] shr attribCode) and $01 ) = 1 then begin
              textColor(hexeditAttribTextColor[attribCode]);
              textBackGround(hexeditAttribBgColor[attribCode]);
            end
            else { show another attributes - UNTAG attribute }
              setMSAttribColor(attrib[ds.curAddr]);{ none attrib }


            write(intToHex(d[ds.curAddr],L));

            ds.curAddr:= ds.curAddr + ds.columns;
          end
          else { scroll screen ... }
            if (dlen-ds.addrOfs)>(ds.columns*ylen) then begin
            ds.addrOfs:=ds.addrOfs+ ds.columns;
            ds.curAddr:=ds.curAddr+ ds.columns;
            scrollScreenUp;
            drawHex(ylen-1,1);
          end;
        end;
      end;
    end;
  until (key=_Esc_) or hexeditExit or sysReq;
  edlineLeaveLRkey:= false;
end;

{
--- message box -------------------------------------------------------
}

procedure viewMsg(var m: TMessages; var ds: TMessagesDescript);
var
  texDS: TtexeditDescript;
begin
  with texDS do begin
    curPos.x:= 0;
    curPos.y:= 0;
    lineOfs:= ds.msgOfs;
    title:= ds.title;
    win:= ds.win;  { cpy window pos }
    editable:= ds.editable;
  end;
  texedit(texDS, m);
end;

{
--- change message box ------------------------------------------------
}
procedure switchMsgBox(var m: TMessages; var ds: TMessagesDescript);
begin
  msgCurMessages:= m;
  msgCurDescript:= @ds;
end;

{            ]
--- addMessage --------------------------------------------------------
}

procedure Msg(m: string);
var
  texDS: TtexeditDescript;
begin
  with texDS do begin
    curPos.x:= 0;
    curPos.y:= 0;
    lineOfs:= msgCurDescript^.msgOfs;

    title:= msgCurDescript^.title;
    win:= msgCurDescript^.win;  { cpy window pos }
    editable:= msgCurDescript^.editable;
  end;
  if msgCurMessages=nil then begin { initialize first message }
    texDS.lineOfs:= 0;
    msgCurDescript^.msgOfs:=0;
  end;
  addLine(msgCurMessages, m);
  if getNLines(msgCurMessages)>(abs(texDS.win.y2-texDS.win.y1)+1) then begin
    deleteLine(msgCurMessages);
  end;
  texeditTextColor:= msgTextColor;
  texeditBgColor:= msgBgColor;
  texeditExit:= true;
  texedit(texDS, msgCurMessages);
  texeditExit:= false;
end;

begin
{ edline presets }
  edlineBgColor:= black;
  edlineTextColor:= lightGray;
  edlineCurPtr:= 0;
  edlineEditOver:= false;    { > length of edline (l) }
  edlineBlankDELETEleave:= false; { leave if string='' and DELETE key pressed }
  edlineCurHomeBACKSPACELeave:= false; { leave if CurPtr=0 + Backspace pressed }
  edlineEveryModify:= false;
  edlineEditable:= true;
  edlineMarkedTextColor:= white;
  edlineMarkedBgColor:= darkGray;
  edlineMarkColumn:= false;
  edlineInsert:= true;

{ texedit presets }
  texeditLeftDist:= 1;
  texeditBgColor:= black;
  texeditTextColor:= lightGray;
  texeditLinesNumbersTextColor:= darkGray;
  texeditLinesNumbersBgColor:= lightGray;
  texeditLineTextColor:= white;
  texeditLineBgColor:= black;
  texeditNumberLines:= false;
  texeditMarkerTextColor:= lightRed;
  texeditMarkerBgColor:= black;
  texeditTitleTextColor:= red;
  texeditTitleBgColor:= cyan;
  texeditLineHighlight:= true;
  texeditEditOver:= true;

  eraseMarkers(texeditMarkers);

{ hexedit presets }
  hexeditBgColor:= blue;
  hexeditTextColor:= yellow;
  hexeditEditBgColor:= cyan;
  hexeditEdittextColor:= black;
  hexeditTitleTextColor:= red;
  hexeditTitleBgColor:= cyan;
  hexeditAddressTextColor:=black;
  hexeditAddressBgColor:= lightGray;
  hexeditEditable:= true;
  hexeditExit:= false;
  hexeditAddrLabel:='';
  hexeditLabelAddr:=0; { address to get label.. }
  hexeditLabelTextColor:= white;
  hexeditLabelBgColor:= hexeditBgColor;


{ msg }
  msgTextColor:= lightGreen;
  msgBgColor:= black;

  for i:=0 to 7 do hexeditAttribKeys[i]:=_null_;
  for i:=0 to 7 do hexeditAttribTextColor[i]:= lightGreen;
  for i:=0 to 7 do hexeditAttribBgColor[i]:=blue;

{ CRT3 presets }
  sysReq:= false;
end.